package com.sa.ibiz.demo.demo.rest;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.sa.ibiz.demo.demo.domain.UserRoleDataDetail;
import com.sa.ibiz.demo.demo.service.UserRoleDataDetailService;
import com.sa.ibiz.demo.demo.service.dto.UserRoleDataDetailSearchFilter;
import com.sa.ibiz.demo.ibizutil.errors.BadRequestAlertException;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.ResponseEntity;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;
import java.math.BigInteger;
import java.util.List;

@RestController
@RequestMapping("/demo/userroledatadetail")
public class UserRoleDataDetailResource
{
	@Autowired
	private UserRoleDataDetailService service;


	@PostMapping(value = "/checkKey")
	public ResponseEntity<UserRoleDataDetail> checkKey(@Validated @RequestBody UserRoleDataDetail data){
		boolean bRt=service.checkKey(data);
		if(!bRt)
			throw new BadRequestAlertException("数据对象能力明细[checkKey]操作发生错误","UserRoleDataDetail",data.getUserroledatadetailid().toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/update")
	public ResponseEntity<UserRoleDataDetail> update(@Validated @RequestBody UserRoleDataDetail data){
		boolean bRt=service.update(data);
		if(!bRt)
			throw new BadRequestAlertException("数据对象能力明细[update]操作发生错误","UserRoleDataDetail",data.getUserroledatadetailid().toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/getDraft")
	public ResponseEntity<UserRoleDataDetail> getDraft(@Validated @RequestBody UserRoleDataDetail data){
		boolean bRt=service.getDraft(data);
		if(!bRt)
			throw new BadRequestAlertException("数据对象能力明细[getDraft]操作发生错误","UserRoleDataDetail","");
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/remove")
	public ResponseEntity<UserRoleDataDetail> remove(@Validated @RequestBody UserRoleDataDetail data){
		boolean bRt=service.remove(data);
		if(!bRt)
			throw new BadRequestAlertException("数据对象能力明细[remove]操作发生错误","UserRoleDataDetail",data.getUserroledatadetailid().toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/create")
	public ResponseEntity<UserRoleDataDetail> create(@Validated @RequestBody UserRoleDataDetail data){
		boolean bRt=service.create(data);
		if(!bRt)
			throw new BadRequestAlertException("数据对象能力明细[create]操作发生错误","UserRoleDataDetail",data.getUserroledatadetailid().toString());
		return ResponseEntity.ok().body(data);
	}
	@GetMapping(value = "/{id}")
	public ResponseEntity<UserRoleDataDetail> get(@Validated @PathVariable String id){
		UserRoleDataDetail data=new UserRoleDataDetail();
		data.setUserroledatadetailid(id);;
		data=service.get(data);
		if(data==null)
			throw new BadRequestAlertException("数据对象能力明细[get]操作发生错误","UserRoleDataDetail",id.toString());
		return ResponseEntity.ok().body(data);
	}
    @PostMapping(value="/searchdefault")
	public ResponseEntity<Page<UserRoleDataDetail>> searchDefaultPage(@Validated @RequestBody UserRoleDataDetailSearchFilter filter){
		Page<UserRoleDataDetail> searchResult = service.searchDefault(filter);
		return ResponseEntity.ok().body(searchResult);
	}

	@PostMapping(value="/listdefault")
	public ResponseEntity<List<UserRoleDataDetail>> listDefault(@Validated @RequestBody UserRoleDataDetailSearchFilter filter){
		List<UserRoleDataDetail> searchResult = service.listDefault(filter);
		return ResponseEntity.ok().body(searchResult);
	}
}
